<template src="./editInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('file-component', FileComponent);

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseBrandStoreObject());
        },

        data() {

            return {

                baseInfo: {

                    name: '',

                    description: '',

                    logo: {

                        file: null,

                        preview: null
                    }
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Assign processed file (image) to logo.
             */
            pushLogo(logo) {

                this.baseInfo.logo = logo;
            },


            /**
             * When brand is loaded parse response object.
             */
            parseBrandStoreObject() {

                let brand = this.$store.state.brand;

                this.baseInfo.name          = brand.name;
                this.baseInfo.description   = brand.description;
                this.baseInfo.logo.preview  = route('images.cache', { template: brand.logo.type, filename: brand.logo.src });
            },


            /**
             * @param brand
             */
            createBrandStoreObject(brand) {

                return {

                    name: brand.name,

                    description: brand.description,

                    logo: brand.logo.file
                }
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setBrand', this.createBrandStoreObject(newBaseInfo));
                },

                deep: true
            }
        }
    }

</script>